<?
//-------------------------------------------
//         DO NOT CHANGE THIS FILE !!! 
//
//  (C) ALGIRDAS.COM 2004 ALL RIGHTS RESERVED
//          HTTP://WWW.ALGIRDAS.COM
//-------------------------------------------
//
/*  
 Title: Message management class.
Author: Algirdas Noreika
e-mail: contact@algirdas.com
   www: http://www.Algirdas.COM 
  info: All rights reserved. Copying and/or distributing any part of this code (software) is strightly prohibited.
*/


//--- SOF Includes and Requires --------------------------------------------------------------
error_reporting(0);
//--- EOF Includes and Requires --------------------------------------------------------------

if (! class_exists('CSECURITYLXFREEV11ALGIRDASCOM')) {

//--- SOF Definitions and Constants ----------------------------------------------------------
//--- EOF Definitions and Constants ----------------------------------------------------------


// --- SOF Class CSECURITYLXFREEV11ALGIRDASCOM
// -------------------------------------------------------------------------------------------
//  CSECURITYLXFREEV11ALGIRDASCOM class is designed to handle website security. It checks all incomming variables
//	to preeserve from JScript, SQL and so on.
class CSECURITYLXFREEV11ALGIRDASCOM {
//  Variables.
	var $_GP;
	var $self;
	var $sParamString;
	var $sURL;
	var $aURLLinkParam;
	var $aURLPostParam;
	var $sURLFileName;
	var $sURLLinkSeparator;
	var $sURLExtension;
	
	
// -------------------------------------------------------------------------------------------
//	Constructor.
	function CSECURITYLXFREEV11ALGIRDASCOM() {
		$this->_GP = Array();
		$this->clearData();
		if (isset($this->_GP['url_parameters'])) {
			$this->parseParameters($this->_GP['url_parameters']);
		}
		$this->sGlobalParams = '';
		$this->aURLPostParam = Array();
		$this->aURLLinkParam = Array();
		$sURL = '';
		$sURLFileName = '';
		$sURLLinkSeparator = '';
		$sURLExtension = '';
	}

//--------------------------------------------------------------------------------------------
//	Clears data from bad text
	function clearData() {
		$this->_GP+=$_GET;
		$this->_GP+=$_POST;
		$aSearch = array("/</",
						 "/\"/",
						 "/'/",
           			      "/>/");               

		$aReplace = array("&#60;",
						  "&#34;",
						  "&#39;",
		                  "&#62;");
		                  
		foreach($this->_GP as $sKey => $sVal) {
			$this->_GP[$sKey] = preg_replace ($aSearch, $aReplace, $sVal);
		}
	}
	
//--------------------------------------------------------------------------------------------
//	Clears data from bad text
	function isParam($sParamName) {
		if (isset($this->_GP[$sParamName])) return true;
		return false;
	}
	
//--------------------------------------------------------------------------------------------
//	Sets parameter Global. It means that parameter is active when page is resubmitted. Parameter is added into Param string for links.
	function setParamGlobal($sParamName) {
		if ($this->isParam($sParamName)) $this->sParamString .= $sParamName."=".$this->_GP[$sParamName]."&";
	}
	
//--------------------------------------------------------------------------------------------
//	Checks if param is number.
	function isNumber($sParamName) {
		return is_numeric($this->_GP[$sParamName]); 
	}
	
//--------------------------------------------------------------------------------------------
//	Checks if param is correct e-mail.
	function isEMail($sParamName) {
		if(!is_numeric($this->_GP[$sParamName])) {
			return preg_match("/^[a-z0-9_-]+@[\.a-z0-9-]+\.[a-z]+$/i",$this->_GP[$sParamName]);
		}
		return false;
	}
	
//--------------------------------------------------------------------------------------------
//	Checks if param is correct e-mail.
	function isHTTPPrefix($sParamName) {
		if(!is_numeric($this->_GP[$sParamName])) {
			return preg_match("/^http(s|):\/\/(.{5,})$/i",$this->_GP[$sParamName]);
		}
		return false;
	}
	
//--------------------------------------------------------------------------------------------
//	Checks if URL is HTTP and domain name only.
	function isURLMainLink($sParamName) {
		if(!is_numeric($this->_GP[$sParamName])) {
			return preg_match("/^http(s|):\/\/([^\/]*)$/i",$this->_GP[$sParamName]);
		}
		return false;
	}
	
//--------------------------------------------------------------------------------------------
//	Checks if param is correct e-mail.
	function isEMailValue($sValue) {
		if(!is_numeric($sValue)) {
			return preg_match("/^[a-z0-9_-]+@[\.a-z0-9-]+\.[a-z]+$/i",$sValue);
		}
		return false;
	}
	
//--------------------------------------------------------------------------------------------
//	Checks if param is null.
	function isNotNull($sParamName) {
		if (!isset($this->_GP[$sParamName])) return false;
		if (is_numeric($this->_GP[$sParamName])) {
			if ($this->_GP[$sParamName] == 0)  return false;
		} else if (is_array($this->_GP[$sParamName])){
			if (count($this->_GP[$sParamName]) == 0) return false;
		} else {
			if (strlen($this->_GP[$sParamName]) == 0)  return false;
		}
		
		return true;
	}
	
//--------------------------------------------------------------------------------------------
//	Checks if String len is OK.
	function isLenOk($sParamName, $iLen) {
		if (strlen($this->_GP[$sParamName]) < $iLen) return true;
		return false;
	}
	
//--------------------------------------------------------------------------------------------
//	Checks URL is OK.
	function hasString($sParamName, $sTestString) {
		return preg_match("/".$sTestString."/i",$this->_GP[$sParamName]);
	}

//--------------------------------------------------------------------------------------------
//	Generates a random string
	function getRandomKey($nLen) {
		$sValue = '';
		for($i=0; $i<($nLen); $i++) {
			$iCharset = rand(1,3);
			switch($iCharset) {
				case 1:
					$iASCII=rand(65,90);
					if ($iASCII == 73) $iASCII = 72;
					break;
				case 2:
					$iASCII=rand(48,57);
					break;
				case 3:
					$iASCII=rand(97,122);
					if ($iASCII == 108) $iASCII = 107;
					break;
			}
			$sValue .= chr($iASCII);
		}
		return $sValue;
	}

//--------------------------------------------------------------------------------------------
//	Formats and returns URL Parameters.
	function preformatURL() {
		
		$this->sURL = $this->sURLFileName;
		$bFirst = true;
		foreach($this->aURLLinkParam as $key => $value) {
			if($bFirst) {
				$this->sURL .= '-';
				$bFirst = false;
			}
			$this->sURL .= $this->sURLLinkSeparator.$key.$value;
		}
		
		$this->sURL .= '.'.$this->sURLExtension;
		
		if (count($this->aURLPostParam)>0) {
			$bFirst = true;
			foreach($this->aURLPostParam as $key => $value) {
				if($bFirst) $this->sURL .= '?';
				else  $this->sURL .= '&';
				$this->sURL .= $key.'='.$value;
				$bFirst = false;
			}
		}
		return $this->sURL;
	}
	
//--------------------------------------------------------------------------------------------
//	Initializes URL.
	function initLinkURL($sFileName, $sLinkSeparator, $sExtension) {
		$this->sURLFileName = $sFileName;
		$this->sURLLinkSeparator = $sLinkSeparator;
		$this->sURLExtension = $sExtension;
	}
	
//--------------------------------------------------------------------------------------------
//	Adds Url Link Parameter.
	function addURLLinkParam($sParamName, $sParamValue) {
		$this->aURLLinkParam[$sParamName] = $sParamValue;
		return $this->preformatURL();
	}
	
//--------------------------------------------------------------------------------------------
//	Removes Url Link Parameter.
	function removeURLLinkParam($sParamName) {
		unset($this->aURLLinkParam[$sParamName]);
		return $this->preformatURL();
	}
	
//--------------------------------------------------------------------------------------------
//	Adds Url Post Parameter.
	function addURLPostParam($sParamName, $sParamValue) {
		$this->aURLPostParam[$sParamName] = $sParamValue;
		return $this->preformatURL();
	}
	
//--------------------------------------------------------------------------------------------
//	Removes Url Link Parameter.
	function removeURLPostParam($sParamName) {
		unset($this->aURLPostParam[$sParamName]);
		return $this->preformatURL();
	}
	
//--------------------------------------------------------------------------------------------
//	Parse Parameters.
	function parseParameters($sParamString) {
		preg_match_all( '/([a-z]+)([0-9]+)/i', $sParamString, $aMatches, PREG_SET_ORDER);
		foreach($aMatches as $aValue){
			$this->_GP[$aValue[1]] = $aValue[2];
		}

	}
}

// -------------------------------------------------------------------------------------------
// --- EOF Class CSECURITYLXFREEV11ALGIRDASCOM
}
?>